Customize expand collapse actions in React Accordion component

30 Jan 202312 minutes to read

Accordion component supports customizing the expand or collapse animation action behavior. You can manually change the expand animation action performed after the collapse animation operation performed on already expand pane when the expand icons are clicked.

By default, the Accordion component pane is expanded or collapsed, when click the expand or collapse icon. It is not affected on already expand pane.

The following sample demonstrates, how to expand the collapsed Accordion item after collapse animation performed on the expanded Accordion item using created, expanding, and expanded event. In the Expanding event, get the previously expanded item index and prevent the expanding behavior using args.cancel option. Expand the Accordion item dynamically based on specifying the index value using the expandItem public method and expanded event.

import * as React from "react";
import { useRef } from "react";
import * as ReactDOM from "react-dom";
import { AccordionComponent, AccordionItemDirective, AccordionItemsDirective } from '@syncfusion/ej2-react-navigations';
const ReactApp = () => {
  let initialLoad = true;
  let isCollapsed = false
  let expandIndex;
  let acrdnInstance = useRef(null)
  const expanded = (e) => {
    if (!e.isExpanded && !initialLoad && isCollapsed) {
      acrdnInstance.current.expandItem(true, expandIndex);
      isCollapsed = false;
    }
  }
  const expanding = (e) => {
    if (e.isExpanded && !initialLoad && !isCollapsed) {
      e.cancel = true;
      expandIndex = acrdnInstance.current.items.indexOf(e.item);
      isCollapsed = true;
    }
  }

  const created = () => {
    initialLoad = false;
  }

  const aspContent = () => {
    return (<div>
      Microsoft ASP.NET is a set of technologies in the Microsoft .NET Framework for building Web applications and XML Web services. ASP.NET pages execute on the server and generate markup such as HTML, WML, or XML that is sent to a desktop or mobile browser. ASP.NET pages use a compiled,event-driven programming model that improves performance and enables the separation of application logic and user interface.
    </div>);
  }

  const mvcContent = () => {
    return (<div>
      The Model-View-Controller (MVC) architectural pattern separates an application into three main components: the model, the view, and the controller. The ASP.NET MVC framework provides an alternative to the ASP.NET Web Forms pattern for creating Web applications. The ASP.NET MVC framework is a lightweight, highly testable presentation framework that (as with Web Forms-based applications) is integrated with existing ASP.NET features, such as master pages and membership-based authentication.
    </div>);
  }

  const jsContent = () => {
    return (<div>
      JavaScript (JS) is an interpreted computer programming language.It was originally implemented as part of web browsers so that client-side scripts could interact with the user, control the browser, communicate asynchronously, and alter the document content that was displayed.More recently, however, it has become common in both game development and the creation of desktop applications.
    </div>);
  }
  return (<AccordionComponent expanded={expanded} expanding={expanding} created={created} expandMode='Single' ref={acrdnInstance}>
    <AccordionItemsDirective>
      <AccordionItemDirective header='ASP.NET' content={aspContent} />
      <AccordionItemDirective header='ASP.NET MVC' content={mvcContent} />
      <AccordionItemDirective header='Javascript' content={jsContent} />
    </AccordionItemsDirective>
  </AccordionComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import * as React from "react";
import { useRef } from "react";
import * as ReactDOM from "react-dom";
import { AccordionComponent, AccordionItemDirective, AccordionItemsDirective } from '@syncfusion/ej2-react-navigations';
const ReactApp = () => {
  let initialLoad = true;
  let isCollapsed = false
  let expandIndex: number;
  let acrdnInstance = useRef(null)
  const expanded = (e: any): void => {
    if (!e.isExpanded && !initialLoad && isCollapsed) {
      acrdnInstance.current.expandItem(true, expandIndex);
      isCollapsed = false;
    }
  }
  const expanding = (e: any): void => {
    if (e.isExpanded && !initialLoad && !isCollapsed) {
      e.cancel = true;
      expandIndex = acrdnInstance.current.items.indexOf(e.item);
      isCollapsed = true;
    }
  }

  const created = (): void => {
    initialLoad = false;
  }

  const aspContent = () => {
    return (<div>
      Microsoft ASP.NET is a set of technologies in the Microsoft .NET Framework for building Web applications and XML Web services. ASP.NET pages execute on the server and generate markup such as HTML, WML, or XML that is sent to a desktop or mobile browser. ASP.NET pages use a compiled,event-driven programming model that improves performance and enables the separation of application logic and user interface.
    </div>);
  }

  const mvcContent = () => {
    return (<div>
      The Model-View-Controller (MVC) architectural pattern separates an application into three main components: the model, the view, and the controller. The ASP.NET MVC framework provides an alternative to the ASP.NET Web Forms pattern for creating Web applications. The ASP.NET MVC framework is a lightweight, highly testable presentation framework that (as with Web Forms-based applications) is integrated with existing ASP.NET features, such as master pages and membership-based authentication.
    </div>);
  }

  const jsContent = () => {
    return (<div>
      JavaScript (JS) is an interpreted computer programming language.It was originally implemented as part of web browsers so that client-side scripts could interact with the user, control the browser, communicate asynchronously, and alter the document content that was displayed.More recently, however, it has become common in both game development and the creation of desktop applications.
    </div>);
  }
  return (<AccordionComponent expanded={expanded} expanding={expanding} created={created} expandMode='Single' ref={acrdnInstance}>
    <AccordionItemsDirective>
      <AccordionItemDirective header='ASP.NET' content={aspContent} />
      <AccordionItemDirective header='ASP.NET MVC' content={mvcContent} />
      <AccordionItemDirective header='Javascript' content={jsContent} />
    </AccordionItemsDirective>
  </AccordionComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 React Accordion Sample</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/material.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='element'>
        <div id='loader'>Loading....</div></div>
</body>
</html>

Customize expand collapse actions in Vue Accordion component

16 Mar 20235 minutes to read

Accordion component supports customizing the expand or collapse animation action behavior. You can manually change the expand animation action performed after the collapse animation operation performed on already expand pane when the expand icons are clicked.

By default, the Accordion component pane is expanded or collapsed, when click the expand or collapse icon. It is not affected on already expand pane.

The following sample demonstrates, how to expand the collapsed Accordion item after collapse animation performed on the expanded Accordion item using created, expanding, and expanded event. In the Expanding event, get the previously expanded item index and prevent the expanding behavior using args.cancel option. Expand the Accordion item dynamically based on specifying the index value using the expandItem public method and expanded event.

<template>
    <div id="app">
    <ejs-accordion ref="acrdnInstance" expandMode='Single' :expanding="expanding" :expanded="expanded" :created="created" >
      <e-accordionitems>
        <e-accordionitem header='ASP.NET' :content='content0'></e-accordionitem>
        <e-accordionitem header='ASP.NET MVC' :content='content1'></e-accordionitem>
        <e-accordionitem header='JavaScript' :content='content2'></e-accordionitem>
      </e-accordionitems>
    </ejs-accordion>
  </div>
</template>
<script>
import Vue from 'vue';
import { AccordionPlugin } from '@syncfusion/ej2-vue-navigations';
import { ExpandEventArgs, Accordion } from '@syncfusion/ej2-navigations';

Vue.use(AccordionPlugin);
export default {  
  name: 'app',
  data: function() {
    return {
        content0: 'ASP.NET is an open-source server-side web application framework designed for web development to produce ' +
        'dynamic web pages. It was developed by Microsoft to allow programmers to build dynamic web sites, web applications ' +
        'and web services. It was first released in January 2002 with version 1.0 of the .NET Framework, and is the successor ' +
        'to Microsoft\'\s Active Server Pages (ASP) technology. ASP.NET is built on the Common Language Runtime (CLR), allowing ' +
        'programmers to write ASP.NET code using any supported .NET language. The ASP.NET SOAP extension framework allows ' +
        'ASP.NET components to process SOAP messages.',

         content1: 'The ASP.NET MVC is a web application framework developed by Microsoft, which implements the ' +
        'model–view–controller (MVC) pattern. It is open-source software, apart from the ASP.NET Web Forms component which is ' +
        'proprietary. In the later versions of ASP.NET, ASP.NET MVC, ASP.NET Web API, and ASP.NET Web Pages (a platform using ' +
        'only Razor pages) will merge into a unified MVC 6.The project is called ASP.NET vNext.',

         content2: 'JavaScript (JS) is an interpreted computer programming language. It was originally implemented as ' +
        'part of web browsers so that client-side scripts could interact with the user, control the browser, communicate ' +
        'asynchronously, and alter the document content that was displayed.[5] More recently, however, it has become common in ' +
        'both game development and the creation of desktop applications.',
    };
  },
  mounted: function() {
    this.initialLoad = true;
    this.isCollapsed = false;
    this.expandIndex;
  },
  methods: {
    expanded: function (e) {
      var obj = this.$refs.acrdnInstance.ej2Instances;
      if (!e.isExpanded && !this.initialLoad && this.isCollapsed) {
           obj.expandItem(true, this.expandIndex);
           this.isCollapsed = false;
      }
    }
    expanding: function (e) {
      var obj = this.$refs.acrdnInstance.ej2Instances;
      if (e.isExpanded && !this.initialLoad && !this.isCollapsed) {
            e.cancel = true;
            this.expandIndex = obj.items.indexOf(e.item);
            this.isCollapsed = true;
      }
    }
    created: function (e) {
        this.initialLoad = false;
    }
   }
}
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>

Customize expand collapse actions in Angular Accordion component

28 Sep 20237 minutes to read

Accordion component supports customizing the expand or collapse animation action behavior. You can manually change the expand animation action performed after the collapse animation operation performed on already expand pane when the expand icons are clicked.

By default, the Accordion component pane is expanded or collapsed, when click the expand or collapse icon. It is not affected on already expand pane.

The following sample demonstrates, how to expand the collapsed Accordion item after collapse animation performed on the expanded Accordion item using created, expanding, and expanded event. In the Expanding event, get the previously expanded item index and prevent the expanding behavior using args.cancel option. Expand the Accordion item dynamically based on specifying the index value using the expandItem public method and expanded event.

import { Component, ViewChild } from '@angular/core';
import { AccordionComponent, AccordionItemModel } from '@syncfusion/ej2-angular-navigations';
import { Accordion, ExpandEventArgs } from '@syncfusion/ej2-navigations';

@Component({
    selector: 'app-container',
    template: `
       <ejs-accordion #element (expanding)="expanding($event)" (expanded)="expanded($event)" (created)="created($event)" expandMode='Single' >
        <e-accordionitems>
          <e-accordionitem>
            <ng-template #header>
              <div>ASP.NET</div>
            </ng-template>
            <ng-template #content>
              <div>Microsoft ASP.NET is a set of technologies in the Microsoft .NET Framework for building Web applications and XML Web
                services. ASP.NET pages execute on the server and generate markup such as HTML, WML, or XML that is sent to a desktop
                or mobile browser. ASP.NET pages use a compiled,event-driven programming model that improves performance and enables
                the separation of application logic and user interface.</div>
            </ng-template>
          </e-accordionitem>
          <e-accordionitem>
            <ng-template #header>
              <div>ASP.NET MVC</div>
            </ng-template>
            <ng-template #content>
              <div>The Model-View-Controller (MVC) architectural pattern separates an application into three main components: the model,
                the view, and the controller. The ASP.NET MVC framework provides an alternative to the ASP.NET Web Forms pattern for
                creating Web applications. The ASP.NET MVC framework is a lightweight, highly testable presentation framework that
                (as with Web Forms-based applications) is integrated with existing ASP.NET features, such as master pages and membership-based
                authentication.
              </div>
            </ng-template>
          </e-accordionitem>
          <e-accordionitem>
            <ng-template #header>
              <div>JavaScript</div>
            </ng-template>
            <ng-template #content>
              <div>JavaScript (JS) is an interpreted computer programming language.It was originally implemented as part of web browsers
                so that client-side scripts could interact with the user, control the browser, communicate asynchronously, and alter
                the document content that was displayed.More recently, however, it has become common in both game development and
                the creation of desktop applications.</div>
            </ng-template>
          </e-accordionitem>
        </e-accordionitems>
    </ejs-accordion>
        `
})

export class AppComponent {
    @ViewChild('element') acrdnInstance?: AccordionComponent;
    public initialLoad = true;
    public isCollapsed = false;
    public expandIndex?: number;
    public expanding(e: ExpandEventArgs) {
        if (e.isExpanded && !this.initialLoad && !this.isCollapsed) {
            e.cancel = true;
            this.expandIndex = (this.acrdnInstance as AccordionComponent).items.indexOf((e as ExpandEventArgs).item as AccordionItemModel);
            this.isCollapsed = true;
      }
    }
    public expanded(e: ExpandEventArgs) {
       if (!e.isExpanded && !this.initialLoad && this.isCollapsed) {
           (this.acrdnInstance as AccordionComponent).expandItem(true, this.expandIndex);
           this.isCollapsed = false;
      }
    }
    public created(args: any): void {
        this.initialLoad = false;
    }
    constructor() {
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AccordionComponent, AccordionItemDirective, AccordionItemsDirective, AccordionModule } from '@syncfusion/ej2-angular-navigations';
import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        AccordionModule
    ],
    declarations: [AppComponent ],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

import 'zone.js';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);